package newCynic;
/**
 *  
 */

public class Radar {
    /**  . */
    private double _oldHeading;
    /**  . */
    private double _currentHeading;
    /**,        . */
    private double _deltaAngle;
    /**   .*/
    private double _radarPath;
    /**  */
    private RadarState _currentState;
    /** - */
    private Cynical _robot;
    /**
     *   .
     * @return ,   
     */
    public RadarState getCurrentState() {
        return _currentState;
    }
    /**
     *   
     * @param aCurrentState  
     */
    public void setCurrentState(RadarState aCurrentState) {
        _currentState = aCurrentState;
    }
    /**
     *   ""   -.
     * @param aRobot 
     */
    public Radar(Cynical aRobot) {
        _robot = aRobot;
        RadarState.reset(this);
    }
    /** ,     .  */
    public void beginRound() {
        _oldHeading = _robot.getRadarHeadingRadians();
        _currentHeading = _robot.getRadarHeadingRadians();
        _deltaAngle = 0;
        _radarPath = 0;
    }
    /** ,       */
    public void beginTurn() {
        _oldHeading = _currentHeading;
        _currentHeading = _robot.getRadarHeadingRadians();
        _radarPath = _radarPath + Cynical.getAngleDiff(_oldHeading, _currentHeading);
        RadarState.processIncomingEvent(10, this);
    }
    /** ,    . */
    public void endTurn() {
        _robot.setTurnRadarRightRadians(_deltaAngle);
    }
/*
      .
*/
    /* x70 :     */
    public boolean x70_scanningIsComplete() {
        boolean result = _robot.getTargets().scanCompleted();
        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x70", "  ", result);
        }
        return result;
    }

    /* x80 :     180   */
    public boolean x80_wholePathIsLesserThan180() {
        boolean result = Math.abs(_radarPath) < Math.PI;
        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x80", "    180 ", result);
        }
        return result;
    }

    /* z100_0 :    */
    public void z100_0_turnLeft() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z100_0", "  ");
        }
        _deltaAngle = -1000;
    }

    /** z100_1 :     */

    public void z100_1_turnRight() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z100_1", "  ");
        }
        _deltaAngle = 1000;
    }

    /** z101_0 :       */
    public void z101_0_resetState() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z101_0", "    ");
        }
        _radarPath = 0;
    }
}
