package newCynic;
/**
 *       ""
 */

public abstract class SupervisorState {
    /**  ,    */
    private String _stateName;
    /** ,   . */
    public String getName() {
        return _stateName;
    }
    /** ,  .     . */
    public SupervisorState(String aStateName) {
        _stateName = aStateName;
    }
    /**
     *   ,  .
     */
    protected void chageParentState(Cynical aRobot, SupervisorState aNewState) {
        changeParentState(aRobot, aNewState);
        aNewState.onEnter(aRobot);
    }
    /**
     *    --  .
     */
    private static void doStartLogging(int aEvent, Cynical aRobot) {
        if (Constants.OBJECTS_LOGGING)
            Logger.log("  '':");

        if (Constants.A0_BEGIN_LOGGING)
            Logger.logBegin(Constants.SUPERVISOR_AUTOMATE_NAME, aRobot.getCurrentState().getName(), aEvent);
    };
    /**
     *    --  .
     */
    private static void doEndLoggint(int aEvent, Cynical aRobot) {
        if (Constants.A0_END_LOGGING)
            Logger.logEnd(Constants.SUPERVISOR_AUTOMATE_NAME, aRobot.getCurrentState().getName());
    };
    /** ,  .   
     *        .
     */
    public abstract void processEvent(Cynical aRobot, int aEvent);
    /** ,       .  
     *         .
     */
    public abstract void onEnter(Cynical aRobot);
    /**  0  "" */
    private static SupervisorState STATE_0 = new SupervisorState0();
    /**  1  "" */
    private static SupervisorState STATE_1 = new SupervisorState1();
    /**  2  "" */
    private static SupervisorState STATE_2 = new SupervisorState2();
    /**  ,   
     *  (     ).
     */
    public static void reset(Cynical aRobot) {
        aRobot.setCurrentState(STATE_0);
    }
    /**
     *  ,    aEvent  aRobot.
     *     .
     */
    public static void processIncomingEvent(int aEvent, Cynical aRobot) {
        doStartLogging(aEvent, aRobot);
        aRobot.getCurrentState().processEvent(aRobot, aEvent);
        doEndLoggint(aEvent, aRobot);
    }
    /**
     *   ,  .
     */
    public static void changeParentState(Cynical aRobot, SupervisorState aState) {
        Logger.logStateChange(Constants.SUPERVISOR_AUTOMATE_NAME, aState.getName(), aRobot.getCurrentState().getName());
        aRobot.setCurrentState(aState);
    }
    /** ,   0  "" */
    private static class SupervisorState0 extends SupervisorState {
        public SupervisorState0() {
            super("State 0");
        }

        public void processEvent(Cynical aRobot, int aEvent) {
            if (aEvent == Constants.EVENT_ROUND_START) {
                aRobot.z10_0_initializeAtStart();
                chageParentState(aRobot, STATE_1);
            }
        }
        public void onEnter(Cynical aRobot) {
        }
    }
    /** ,   1  "" */
    private static class SupervisorState1 extends SupervisorState {

        public SupervisorState1() {
            super("State 1");
        }

        public void processEvent(Cynical aRobot, int aEvent) {
            if (aEvent == Constants.EVENT_DEATH || aEvent == Constants.EVENT_WIN) {
                chageParentState(aRobot, STATE_2);
            }
            else if (aEvent == Constants.EVENT_STEP_START) {
                aRobot.z10_2_requestInputParametersAtNewStep();
            }
        }

        public void onEnter(Cynical aRobot) {
            aRobot.z10_1_initializeAtNewRound();
            aRobot.z10_2_requestInputParametersAtNewStep();
        }
    }
    /** ,   2  "" */
    private static class SupervisorState2 extends SupervisorState {
        public SupervisorState2() {
            super("State 2");
        }

        public void processEvent(Cynical aRobot, int aEvent) {
            if (aEvent == Constants.EVENT_ROUND_START) {
                chageParentState(aRobot, STATE_1);
            }
        }

        public void onEnter(Cynical aRobot) {
            aRobot.z20_printRoundStatistics();
        }
    }
}
