package newCynic;

import robocode.Event;
import robocode.ScannedRobotEvent;

/**  "".*/

public class Target {
/*
    .
*/
    private static final double LONG_RANGE_DISTANCE = 650;
    private static final double CLOSE_RANGE_DISTANCE = 150;
    private static final double POINT_BLANK_RANGE = 70;
    /**  ,  
     *   .
     */
    private static final long ROUNDS_TO_MAKE_INFO_INVALID = 20;
    private static final double INITILAL_PROBABILITY =  1.2;
    private static final double _Tbase = 3;
/*
     .
*/
    /**  .*/
    private String _name;
    /** .*/
    public double _angle;
    /**. */
    public double _distance;
    /** . */
    private double _velocity;
    /**   . */
    private double _averageVelocity;
    /** . */
    private double _angularVelocity;
    /**   .*/
    private double _averageAngularVelocity;
    /**   */
    private boolean _collisionDetected;
    /**      .*/
    private double _recentTargetHeading;
    /**      .*/
    private double _oldTargetHeading;
    /**     .*/
    private long _lastUpdateTime;
    /**      . */
    private GeomVector _predictionVector = new GeomVector();
    /**   */
    private double _TargetEnergy;
    /**    */
    private double _hits;
    /**     */
    private double _shots;
    /**   */
    private double _baseProbability;
    /**   */
    private double _Taverage;
   /** -*/
    private Cynical _cynical;
    /**   */
    private TargetState _currentState;
    /**
     *   .
     * @return ,   
     */
    public TargetState getCurrentState() {
        return _currentState;
    }

    /**
     *   
     * @param aNewState  
     */
    public void setCurrentState(TargetState aNewState) {
        _currentState = aNewState;
    }

    /** . */
    Target(Cynical aCynical, ScannedRobotEvent e) {
        _cynical = aCynical;
        _name = e.getName();
        _angle = Cynical.normalizeAngle(_cynical.getHeadingRadians()
                + e.getBearingRadians());
        _distance = e.getDistance();
        _averageVelocity = _velocity = e.getVelocity();
        _averageAngularVelocity = 0;
        _angularVelocity = 0;
        _oldTargetHeading = _recentTargetHeading = e.getHeadingRadians();
        _lastUpdateTime = _cynical._currentTime;
        _hits = 0;
        _shots = 0;
        _Taverage = 3;
        _baseProbability = 1;
        TargetState.reset(this);
        TargetState.processIncomingEvent(Constants.EVENT_UPDATE, this, e);
    }

    /**  . */
    public void beginRound() {
        TargetState.processIncomingEvent(Constants.EVENT_START_ROUND, this, null);
    }

    /**   . */
    public void targetRefresh() {
        TargetState.processIncomingEvent(Constants.EVENT_REFRESH, this, null);
    }

    /**  . */
    public void targetUpdate(ScannedRobotEvent aEvent) {
        TargetState.processIncomingEvent(Constants.EVENT_UPDATE, this, aEvent);
    }

    /**  .*/
    public void targetDestroyed() {
        TargetState.processIncomingEvent(Constants.EVENT_DESTROYED, this, null);
    }

    /**   .*/
    public void targetHit() {
        TargetState.processIncomingEvent(Constants.EVENT_HIT, this, null);
    }

    /**   . */
    public void collision() {
        TargetState.processIncomingEvent(Constants.EVENT_COLLISION, this, null);
    }

    /**   . */
    public void hitByBullet() {
        TargetState.processIncomingEvent(Constants.EVENT_WE_WERE_HIT, this, null);
    }

    /**   . */
    public void shoot(double firepower) {
        double T = _predictionVector.getRadius() / Cynical.getBulletSpeed(firepower);
        T = Math.max(T, 1);
        double P = INITILAL_PROBABILITY - T * (INITILAL_PROBABILITY - _baseProbability) / _Tbase;
        P = Math.min(P, INITILAL_PROBABILITY);
        P = Math.max(P, 0);
        //log( ", P = " + P + ", F = " + firepower ) ;
        P = P / 1.2;
        _baseProbability = INITILAL_PROBABILITY - _Tbase * (INITILAL_PROBABILITY - P) / T;
        _baseProbability = Math.min(_baseProbability, INITILAL_PROBABILITY);
        _baseProbability = Math.max(_baseProbability,0);
        _Taverage = (_Taverage + T) / 2;
        _shots++;
    }

    /**   . */
    public void resetSpeedHistory() {
        _averageAngularVelocity = _angularVelocity;
        _averageVelocity = _velocity;
    }

    /**  . */
    public boolean isTracked() {
        return TargetState.targetIsTracked(this);
    }

    /**       . */
    public boolean wasUpdatedAfter(long scan_time) {
        return _lastUpdateTime > scan_time;
    }

    /**       . */
    public double getOptimalFirePower(double P) {
        double R = _predictionVector.getRadius();
        double S = (INITILAL_PROBABILITY - _baseProbability) * R / ((INITILAL_PROBABILITY - P) * _Tbase);
        double resultFirePower = (20 - S) / 3.0;

        //log( "F = " + F ) ;
        resultFirePower = Math.min(resultFirePower,Cynical.MAX_FIRE_POWER );

        double damage;
        if (resultFirePower > 1) {
            damage = resultFirePower * 3 + (2 * (resultFirePower - 1) );
        } else {
            damage = resultFirePower * 3 ;
        }
        if (damage > _TargetEnergy) {
            if (_TargetEnergy < 3) {
                resultFirePower = _TargetEnergy / 3.0;
                resultFirePower = resultFirePower < 0.1 ? 0.1 : resultFirePower;
            } else {
                resultFirePower = (_TargetEnergy + 2.0) / 5.0;
            }
        }
        if (resultFirePower < 0.1) {
            if ((R < LONG_RANGE_DISTANCE) && (_cynical._currentEnegy > Cynical.ENERGY_WARNING_THRESHOLD)) {
                resultFirePower = 0.1;
            } else if ((_TargetEnergy > _cynical._currentEnegy)
                    && ((_cynical._currentTime - _cynical._lastShotTime) > Cynical.FIRE_DELAY_CRITICAL)) {
                resultFirePower = 0.1;
            }
        } else {
            if (_cynical._currentEnegy < Cynical.ENERGY_CRITICAL_THRESHOLD) {
                resultFirePower = Math.min(resultFirePower,_cynical._currentEnegy / 5);
                resultFirePower = Math.max(resultFirePower, 0.1);
                if (_cynical._currentEnegy < 0.2) {
                    resultFirePower = 0;
                }
            }
        }
        return resultFirePower;
    }

    /**   . */
    public GeomVector calculateRoughPrediction(double aBuletSpeed, double aPredictionGap) {
        double curBulletTime;
        curBulletTime = aPredictionGap + _distance / aBuletSpeed;
        _predictionVector.setCoords(_angle, _distance);
        if (_distance > CLOSE_RANGE_DISTANCE) {
            if (Math.abs(_velocity) > Cynical.PRECISION) {
                _predictionVector.add(get_path(_averageVelocity, _averageAngularVelocity,
                        _recentTargetHeading, curBulletTime));
            }
        }
        return _predictionVector;
    }

    /**   . */
    public GeomVector calculateAveragePrediction(double aBulletSpeed, double aPredictionGap) {
        predictPosition(_averageVelocity, _averageAngularVelocity, aBulletSpeed, aPredictionGap);
        return _predictionVector;
    }

    /**  . */
    public void logStatisitics() {
        Logger.log("----   " + _name + " ----");
        Logger.log(": " + _shots + ", : " + _hits);
        Logger.log(": " + _hits / _shots + ", : " + _baseProbability);
        Logger.log("---------");
    }
/*
      .
*/
    /** x1000 :    .*/
    public boolean x1000_targetDataIsOutOfDate() {
        boolean result = (_cynical._currentTime - _lastUpdateTime) > ROUNDS_TO_MAKE_INFO_INVALID;

        if (Constants.INPUTS_LOGGING) {
            Logger.logInput("x1000", "   ", result);
        }
        return result;
    }
/*
      .
*/
    /** z1000 :   .*/
    public void z1000_resetTargetData() {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z1000", "  ");
        }
        _averageAngularVelocity = 0;
        _angularVelocity = 0;
        _averageVelocity = _velocity = 0;
        _lastUpdateTime = 0;
        _predictionVector.reset();
    }

    /** z1001 :   .*/
    public void z1001_updateTargetData(Event event) {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z1001", "  ");
        }

        if (_lastUpdateTime != _cynical._currentTime) //   .
        {
            ScannedRobotEvent e = (ScannedRobotEvent) event;
            _TargetEnergy = e.getEnergy();
            _distance = Math.abs(e.getDistance());
            _angle = Cynical.normalizeAngle(_cynical.getHeadingRadians() + e.getBearingRadians());
            _velocity = e.getVelocity();
            _averageVelocity = (_velocity + _averageVelocity) / 2.0;
            _oldTargetHeading = _recentTargetHeading;
            _recentTargetHeading = Cynical.normalizeAngle(e.getHeadingRadians());
            _angularVelocity = Cynical.getAngleDiff(_oldTargetHeading, _recentTargetHeading)
                    / (_cynical._currentTime - _lastUpdateTime);
            _averageAngularVelocity = (_angularVelocity + _averageAngularVelocity) / 2.0;
            _lastUpdateTime = _cynical._currentTime;
        }
    }
    /** z1010 :     .*/
    public void z1010_updateTargetHitStatistics(Event e) {
        if (Constants.OUTPUTS_LOGGING) {
            Logger.logOutput("z1010", "    ");
        }
        double P = INITILAL_PROBABILITY - _Taverage * (INITILAL_PROBABILITY - _baseProbability) / _Tbase;
        P = P * 1.4;
        P = Math.min(P,INITILAL_PROBABILITY);
        P = Math.max(P,0);

        _baseProbability = INITILAL_PROBABILITY - _Tbase * (INITILAL_PROBABILITY - P) / _Taverage;
        _baseProbability = Math.min(_baseProbability, INITILAL_PROBABILITY);
        _baseProbability = Math.max(_baseProbability,0);

        _hits++;
    }
/*
     .
*/
    /**    :
     * <ul>
     * <li>    ;
     * <li>,       prediction_gap.
     * </ul>
     */
    private void predictPosition(double v, double w,
                             double bullet_speed, double prediction_gap) {
        final int maximum_iterations = 5;
        double old_bullet_time, cur_bullet_time;
        int i = 0;
        GeomVector cur_prediction = new GeomVector();
        if (_distance < POINT_BLANK_RANGE) {
            cur_prediction.setCoords(_angle, _distance);
        } else if (Math.abs(v) > Cynical.PRECISION) {
            old_bullet_time = cur_bullet_time = prediction_gap + _distance / bullet_speed;
            _collisionDetected = false;
            cur_prediction = get_predicted_point(v, w, cur_bullet_time, true);
            if (!_collisionDetected)
                for (i = 0; i < maximum_iterations; i++) {
                    old_bullet_time = cur_bullet_time;
                    cur_bullet_time = prediction_gap + cur_prediction.getRadius() / bullet_speed;
                    if (Math.abs(cur_bullet_time - old_bullet_time) < 0.5) break;
                    cur_prediction = get_predicted_point(v, w, cur_bullet_time, false);
                }
        } else {
            cur_prediction.setCoords(_angle, _distance);
        }
        _predictionVector.setCoords(cur_prediction.getAngle(), cur_prediction.getRadius());
    }

    /**       . */
    private GeomVector get_predicted_point(double v, double w,
                                double t, boolean check_collisions) {
        GeomVector cur_prediction = new GeomVector(_angle, _distance);
        //    ,    
        //     .
        double time_discret = 5;
        if (check_collisions) {
            //  (  )   
            //    .
            //       
            //       .
            //      - 
            //       
            //       .
            for (double i = 0; i * time_discret < t; i++) {
                double time_delta = Math.min(time_discret,
                        t - i * time_discret);
                cur_prediction.add(get_path(v, w, _recentTargetHeading, time_delta));
                if (vector_out_of_field(cur_prediction)) {
                    //  .
                    //  ,    ,
                    //    [i*time_discret ; i*time_discret + time_delta].
                    //    .
                    _collisionDetected = true;
                    cur_prediction.setCoords(_angle, _distance);
                    cur_prediction.add(get_path(v, w, _recentTargetHeading, i * time_discret));
                    for (int j = 1; j <= time_delta; j++) {
                        cur_prediction.add(get_path(v, w, _recentTargetHeading, 1));
                        if (vector_out_of_field(cur_prediction)) {
                            //        .
                            //   i*time_discret + j.
                            //        .
                            cur_prediction.setCoords(_angle, _distance);
                            cur_prediction.add(
                                    get_path(v, w, _recentTargetHeading, i * time_discret + j));
                            return cur_prediction;
                        }
                    }

                    //   ,   -    
                    //  ,    .
                    cur_prediction.setCoords(_angle, _distance);
                    cur_prediction.add(
                            get_path(v, w, _recentTargetHeading, i * time_discret + time_delta));
                    return cur_prediction;
                }
            }  // for   .
        } // if( check_collisions )

        //   ,        .
        cur_prediction.setCoords(_angle, _distance);
        cur_prediction.add(
                get_path(v, w, _recentTargetHeading, t));

        return cur_prediction;
    }

    /** ,   ,  
    *      .
    */
    private boolean vector_out_of_field(GeomVector vector) {
        double x, y;
        x = _cynical.getX() + vector.getX();
        y = _cynical.getY() + vector.getY();

        return (x < 0 + _cynical._collisionDelta
                || x > _cynical._battleFieldWidth - _cynical._collisionDelta
                || y < 0 + _cynical._collisionDelta
                || y > _cynical._battleFieldHeight - _cynical._collisionDelta);
    }

    /**      ,  ,
     *   .
     */
    public static GeomVector get_path(double v, double w, double heading, double T) {
        GeomVector path;
        if (Math.abs(w) > Cynical.PRECISION) {
            //   .
            double R = Math.abs(v / w);
            double to_circle_center, from_circle_center;

            to_circle_center = Cynical.normalizeAngle(
                    w * v >= 0 ?
                    heading + Cynical.HALF_PI :
                    heading - Cynical.HALF_PI);
            from_circle_center = Cynical.normalizeAngle(to_circle_center + Math.PI + w * T);

            path = new GeomVector(to_circle_center, R);
            path.addRadialVector(from_circle_center, R);
        } else {
            //   .
            path = new GeomVector(heading, v * T);
        }
        return path;
    }

    /**   . */
    public String getName() {
        return _name;
    }
}
